var nomi_checkbox = ["bbcodextra-enable-bbcode", "bbcodextra-enable-vbulletin", "bbcodextra-enable-html", "bbcodextra-enable-xhtml"];	   
var preferenze;

if (!preferenze) {
	preferenze = Components.classes["@mozilla.org/preferences;1"].getService();
	preferenze = preferenze.QueryInterface(Components.interfaces.nsIPref);
	}

var bbcodextra = {

	init: function() {
		var menu = document.getElementById('contentAreaContextMenu');		
		menu.addEventListener('popupshowing', bbcodextra.showHide, false);						
		
		// localizing initial description at startup :o)
   var bbcodextraLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{af79f858-4b25-4ca4-822b-b5db1be628fc}.");
   var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
   str.data = document.getElementById("strRes").getString("BBCODEXTRA_DESCRIPTION");
   bbcodextraLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );
		
		

		//Imposto i valori predefiniti per le preferenze (tutti i menu visibili); mettendoli qui lo faccio solo una volta
		//evitando di appesantire il tutto
		preferenze.SetDefaultBoolPref("bbcodextra.bbcodemenu", true);
		preferenze.SetDefaultBoolPref("bbcodextra.htmlmenu", true);
		preferenze.SetDefaultBoolPref("bbcodextra.xhtmlmenu", true);
		preferenze.SetDefaultBoolPref("bbcodextra.bbcodevbulletinmenu", true);
	},	
	
	

	showHide: function() {
		var enableBBCodeMenu, enableVBulletinMenu, enableHtmlMenu, enableXhtmlMenu;
				
		//Leggo i valori effettivi delle preferenze
		enableBBCodeMenu = preferenze.GetBoolPref("bbcodextra.bbcodemenu");
		enableHtmlMenu = preferenze.GetBoolPref("bbcodextra.htmlmenu");
		enableXhtmlMenu = preferenze.GetBoolPref("bbcodextra.xhtmlmenu");
		enableVBulletinMenu = preferenze.GetBoolPref("bbcodextra.bbcodevbulletinmenu");	
				
		if(enableBBCodeMenu){
      				     document.getElementById('context-bbcodextra-bbcode').hidden = document.getElementById('context-undo').hidden;
				     //Il menu VBulletin  visibile solo quando il BBCode  attivo
				     if(enableVBulletinMenu){
      				       document.getElementById('bbcode-vbulletinmenu').hidden = document.getElementById('context-undo').hidden;
    			               }else{
      				        document.getElementById('bbcode-vbulletinmenu').hidden = true;
    			               }				    
    			            }else{
      				     document.getElementById('context-bbcodextra-bbcode').hidden = true;
    			            }
		
		
				    
		if(enableHtmlMenu){
      				     document.getElementById('context-bbcodextra-html').hidden = document.getElementById('context-undo').hidden;;
    			            }else{
      				     document.getElementById('context-bbcodextra-html').hidden = true;
    			            }

		if(enableXhtmlMenu){
      				     document.getElementById('context-bbcodextra-xhtml').hidden = document.getElementById('context-undo').hidden;
    			            }else{
      				     document.getElementById('context-bbcodextra-xhtml').hidden = true;
    			            }				    				    		
		
		
	},

		

	disableMenu: function (idPref) {		
		//Scrivo false nella preferenza
		preferenze.SetBoolPref(idPref,false);
	},	
	
	
	promptWindow: function (stringa){
		//Questa funzione serve a risolvere il bug relativo alla funzione prompt
		//https://bugzilla.mozilla.org/show_bug.cgi?id=282341

		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                    .getService(Components.interfaces.nsIPromptService);
		var result = {value:null};
		
		promptService.prompt(null, "BBCodeXtra", stringa, result, null, {value:0});		
 		return result.value;
	},
	
		
	showPreferences: function() {
		window.openDialog('chrome://bbcodextra/content/bbcodextraPrefs.xul', '_blank', 'chrome,dialog,modal,centerscreen'); 	
	},
	
	

	showColorPick: function() {			
		var colore;
		window.openDialog('chrome://bbcodextra/content/bbcodextraPickColor.xul', '_blank', 'chrome,dialog,modal,centerscreen');	        
		if (preferenze.GetBoolPref("bbcodextra.bbcodeconferma")) {
					//Entro in questo ciclo solo se  stato premuto OK
					colore=preferenze.GetCharPref("bbcodextra.bbcodecolore");					
					bbcodextra.bbcodextra('color', colore);					
				    }
	},	
	
	
	
	memorizzaColore: function(){          		
		//Salvo in una preferenza il valore scelto dall'utente				
		preferenze.SetCharPref("bbcodextra.bbcodecolore", document.getElementById('BBCodeXtraSelectedColor').color);		
		preferenze.SetDefaultBoolPref("bbcodextra.bbcodeconferma", true);
		return true;
  	},
	
	
	
	annullaCambiaColore: function(){          		
		//Annullo il cambiamento di colore		
		preferenze.SetDefaultBoolPref("bbcodextra.bbcodeconferma", false);
  	},	
	

				
	caricaColore: function(){          		
		//imposto il colore sull'ultimo colore selezionato
		document.getElementById('BBCodeXtraSelectedColor').color=preferenze.GetCharPref("bbcodextra.bbcodecolore");
		document.getElementById('coloreSelezionato').style.backgroundColor=preferenze.GetCharPref("bbcodextra.bbcodecolore"); 
  	},
	
	
	
	bbcodextra: function(myCommand,extraParam) { 	
		var clip = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
    		if (!clip){
      			return false;
    		}
    
   		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
    		if (!trans){
      			return false;
    		}
    
      		trans.addDataFlavor("text/unicode");
      		clip.getData(trans,clip.kGlobalClipboard);		
    
    		var str = null;
    		var str_clipboard=new Object();
    		var strLength=new Object();		
    		try{
      			trans.getTransferData("text/unicode",str_clipboard,strLength);
  
  
      			if (str_clipboard){
        			str_clipboard=str_clipboard.value.QueryInterface(Components.interfaces.nsISupportsString);
      			}
      			if (str_clipboard){
        			pastetext=str_clipboard.data.substring(0,strLength.value / 2);
      			}
    		}catch (e){
      			//alert("No text in the clipboard, please copy something first.");
    		}
    
		var theBox = document.commandDispatcher.focusedElement;
		var oPosition = theBox.scrollTop;
		var oHeight = theBox.scrollHeight;
    
    
    		//Get Selected text (if selected)
      		var startPos = theBox.selectionStart;
      		var endPos = theBox.selectionEnd;
      		str = theBox.value.substring(startPos, endPos);

    		bbcodextra.insertAtCursorSetup(myCommand, str_clipboard, str, theBox, extraParam);
		var nHeight = theBox.scrollHeight - oHeight;
		theBox.scrollTop = oPosition + nHeight;
	},





  	insertAtCursorSetup: function(myCommand, str_clipboard, str, theBox, extraParam) {
  		// Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  		// Modified to return cursor to correct place
		//extraParam al momento  usato solo dalla funzione per il colore
  				
	  	//variabili per la composizione del wizard-url
	  	var indcomposto = null;
	  	var nomecomposto = null;
		//variabili per il quote
		var autore = null;	
		var stringa = null;	
		
		//variabili per la localizzazione delle stringhe javascript.
		var strRes = document.getElementById('strRes');		
		var strInsAuthor = strRes.getString("INS_AUTHOR");  
		var strInsLinkName = strRes.getString("INS_LINKNAME");
		var strInsFontSize = strRes.getString("INS_FONTSIZE");
		var strInsFontColor = strRes.getString("INS_FONTCOLOR");
		var strInsThreadNum = strRes.getString("INS_THREADNUM");
		var strInsPostNum = strRes.getString("INS_POSTNUM");
		var strUrlCompostoStep1 = strRes.getString("URLCOMPOSTO_STEP1");
		var strUrlCompostoStep2 = strRes.getString("URLCOMPOSTO_STEP2");
		var pos = 0;
		var clipb = ""
		
		switch (myCommand){
      		case "quoteclip":
        		autore = bbcodextra.promptWindow(strInsAuthor);
			clipb = str_clipboard ;
			clipb = clipb.replace(/Quote:\nOriginally Posted by /g,"[Quote=\"") ;
			clipb = clipb.replace(/\n\n/g, "[/quote]") ;
			while( pos = clipb.indexOf("=\"") {
				pos = clipb.lastIndexOf("\n", pos) ;
				clipb = clipb.substr(0,pos-1) + "\"]" + clipb.substr(pos+1, clipb.length-1) ;
			}
			if (autore==null) {
					bbcodextra.insertAtCursor("[quote]" + clipb + "[/quote]");
					} else {
				     		bbcodextra.insertAtCursor("[quote=\""+ autore +"\"]" + clipb + "[/quote]");
						}
        	break;
        
      		case "quote":
		        autore = bbcodextra.promptWindow(strInsAuthor);
			if (autore==null) {
					bbcodextra.insertAtCursor("[quote]" + str + "[/quote]");
					} else {
				     		bbcodextra.insertAtCursor("[quote=\""+ autore +"\"]" + str + "[/quote]");
						}        		
        	break;
        
      		case "img":
        		bbcodextra.insertAtCursor("[img]" + str + "[/img]");
        	break;

      		case "imgclip":
        		bbcodextra.insertAtCursor("[img]" + str_clipboard + "[/img]");
        	break;

      		case "codeclip":
        		bbcodextra.insertAtCursor("[code]" + str_clipboard + "[/code]");
        	break;
        
	  	case "urltag":
        		bbcodextra.insertAtCursor("[url]" + str + "[/url]");
        	break;  

	 	case "urltagname":
			stringa = null;
			stringa = bbcodextra.promptWindow(strInsLinkName);
			if (stringa!=null) {	bbcodextra.insertAtCursor("[url=" + str + "]" + stringa + "[/url]"); };
        	break;
	  
	  	case "url":
        		bbcodextra.insertAtCursor("[url]" + str_clipboard + "[/url]");
        	break;
        
      		case "urlclip":
        		stringa = null;
			stringa = bbcodextra.promptWindow(strInsLinkName);
			if (stringa!=null) { bbcodextra.insertAtCursor("[url=" + str_clipboard + "]" + stringa + "[/url]"); }
        	break;
		
		case "urlselection":
        		bbcodextra.insertAtCursor("[url=" + str_clipboard + "]" + str + "[/url]");
        	break;

	  	case "urlcomposto":			
			nomecomposto = bbcodextra.promptWindow(strUrlCompostoStep1);
			if (nomecomposto!=null) {
					      	     indcomposto = bbcodextra.promptWindow(strUrlCompostoStep2);
						     if (indcomposto!=null) { bbcodextra.insertAtCursor("[url=" + indcomposto + "]" + nomecomposto + "[/url]");}
						   }  
        	break;
        
      		case "bold":
        		bbcodextra.insertAtCursor("[b]" + str + "[/b]");
        	break;

      		case "lista":
        		bbcodextra.insertAtCursor("[list]\n[*]" + bbcodextra.replace_CR(str,"[*]*") + "\n[/list]");
        	break;
		
		case "listanum":
        		bbcodextra.insertAtCursor("[list=1]\n[*]" + bbcodextra.replace_CR(str,"[*]*") + "\n[/list]");
        	break;
		
		case "listaalf":
        		bbcodextra.insertAtCursor("[list=a]\n[*]" + bbcodextra.replace_CR(str,"[*]*") + "\n[/list]");
        	break;
       
      		case "listaclip":       
        		bbcodextra.insertAtCursor("[list]\n[*]" + bbcodextra.replace_CR(str_clipboard,"[*]*") + "\n[/list]");
        	break; 
		
		case "listaclipnum":
        		bbcodextra.insertAtCursor("[list=1]\n[*]" + bbcodextra.replace_CR(str_clipboard,"[*]*") + "\n[/list]");
        	break;
		
		case "listaclipalf":
        		bbcodextra.insertAtCursor("[list=a]\n[*]" + bbcodextra.replace_CR(str_clipboard,"[*]*") + "\n[/list]");
        	break;

      		case "italic":
        		bbcodextra.insertAtCursor("[i]" + str + "[/i]");
        	break;
        
      		case "underline":
        		bbcodextra.insertAtCursor("[u]" + str + "[/u]");
        	break;
        
      		case "code":
        		bbcodextra.insertAtCursor("[code]" + str + "[/code]");
        	break;
        
      		case "size":
			stringa = null;
			stringa = bbcodextra.promptWindow(strInsFontSize);
			if (stringa!=null) { bbcodextra.insertAtCursor("[size=" + stringa + "]" + str + "[/size]"); }
        	break;

      		case "color":
        		bbcodextra.insertAtCursor("[color=" + extraParam + "]" + str + "[/color]");
        	break;
		
		//VBULLETIN SECTION
		
      		case "vbulthread":
        		stringa = null;
			stringa = bbcodextra.promptWindow(strInsThreadNum);
			if (stringa!=null) { bbcodextra.insertAtCursor("[thread=" + stringa + "]" + str + "[/thread]"); }
        	break;
		
		case "vbulpost":
        		stringa = null;
			stringa = bbcodextra.promptWindow(strInsPostNum);        		
			if (stringa!=null) { bbcodextra.insertAtCursor("[post=" + stringa + "]" + str + "[/post]"); }
        	break;		
		
      		case "vbulleft":
        		bbcodextra.insertAtCursor("[left]" + str + "[/left]");        
        	break;
		
		case "vbulright":
        		bbcodextra.insertAtCursor("[right]" + str + "[/right]"); 
        	break;	
		
      		case "vbulcenter":
        		bbcodextra.insertAtCursor("[center]" + str + "[/center]");        
        	break;
		
		case "vbulindent":
        		bbcodextra.insertAtCursor("[indent]" + str + "[/indent]"); 
        	break;	
		
      		case "vbulhighlight":
        		bbcodextra.insertAtCursor("[highlight]" + str + "[/highlight]");        
        	break;
		
		
		//HTML SECTION
		
		case "htmlbold":
        		bbcodextra.insertAtCursor("<b>" + str + "</b>");
        	break;
		
		case "htmlitalic":
        		bbcodextra.insertAtCursor("<i>" + str + "</i>");
        	break;
		
		case "htmlunderline":
        		bbcodextra.insertAtCursor("<u>" + str + "</u>");
        	break;		
		
      		case "htmlimg":
        		bbcodextra.insertAtCursor("<img src=\"" + str + "\">");
        	break;		
		
		case "htmlimgclip":
        		bbcodextra.insertAtCursor("<img src=\"" + str_clipboard + "\">");
        	break;	
		
      		case "htmlstrike":
        		bbcodextra.insertAtCursor("<s>" + str + "</s>");
        	break;		
		
   
		//XHTML SECTION
		case "xhtmlbold":
        		bbcodextra.insertAtCursor("<strong>" + str + "</strong>");
        	break;
		
		case "xhtmlitalic":
        		bbcodextra.insertAtCursor("<em>" + str + "</em>");
        	break;
		
		case "xhtmlunderline":
        		bbcodextra.insertAtCursor("<ins>" + str + "</ins>");
        	break;		
		
      		case "xhtmlimg":
        		bbcodextra.insertAtCursor("<img src=\"" + str + "\"/>");
        	break;		
		
		case "xhtmlimgclip":
        		bbcodextra.insertAtCursor("<img src=\"" + str_clipboard + "\"/>");
        	break;	
				
      		case "xhtmlstrike":
        		bbcodextra.insertAtCursor("<del>" + str + "</del>");
        	break;	
		
		//FUNZIONI COMUNI HTML/XHTML		
		
      		case "xhtmlurltag":
        		bbcodextra.insertAtCursor("<a href=\"" + str + "\">" + str + "</a>");
        	break;		
		
		case "xhtmlquoteclip":
        		bbcodextra.insertAtCursor("<blockquote>" + str_clipboard + "</blockquote>");
        	break;
		
		case "xhtmlquote":
        		bbcodextra.insertAtCursor("<blockquote>" + str + "</blockquote>");
        	break;
		
		case "xhtmlurl":
        		bbcodextra.insertAtCursor("<a href=\""+str_clipboard+"\">"+str_clipboard +"</a>");
        	break;
        
      		case "xhtmlurlclip":
        		stringa = null;
			stringa = bbcodextra.promptWindow(strInsLinkName); 
			if (stringa!=null) { bbcodextra.insertAtCursor("<a href=\""+str_clipboard+"\">" + stringa +"</a>"); }
        	break;
		
		case "xhtmlurlselection":
        		bbcodextra.insertAtCursor("<a href=\""+str_clipboard+"\">"+str+"</a>");
        	break;
		
		case "xhtmlurltagname":
        		stringa = null;
			stringa = bbcodextra.promptWindow(strInsLinkName); 
			if (stringa!=null) { bbcodextra.insertAtCursor("<a href=\""+str+"\">"+ stringa +"</a>"); }
        	break;		
		
		case "xhtmlurlcomposto":
	    		nomecomposto = bbcodextra.promptWindow(strUrlCompostoStep1);
            		if (nomecomposto!=null) { 
							indcomposto = bbcodextra.promptWindow(strUrlCompostoStep2);			
	    						if (indcomposto!=null) { bbcodextra.insertAtCursor("<a href=\""+indcomposto+"\">"+ nomecomposto +"</a>"); }
						   }	
        	break;
		
		case "xhtmllista":
        		bbcodextra.insertAtCursor("<ul>\n<li>" + bbcodextra.htmlreplace_CR(str,"[*]*") + "</li>\n</ul>");
        	break;
		
		case "xhtmllistanum":
        		bbcodextra.insertAtCursor("<ul>\n<ol>\n<li>" + bbcodextra.htmlreplace_CR(str,"[*]*") + "</li>\n</ol>\n</ul>");
        	break;
		
		case "xhtmllistaalf":
        		bbcodextra.insertAtCursor("<ul>\n<ol type=a>\n<li>" + bbcodextra.htmlreplace_CR(str,"[*]*") + "</li>\n</ol>\n</ul>");
        	break;				
		
		case "xhtmllistaclip":
        		bbcodextra.insertAtCursor("<ul>\n<li>" + bbcodextra.htmlreplace_CR(str_clipboard,"[*]*") + "</li>\n</ul>");
        	break;
		
		case "xhtmllistanumclip":
        		bbcodextra.insertAtCursor("<ul>\n<ol>\n<li>" + bbcodextra.htmlreplace_CR(str_clipboard,"[*]*") + "</li>\n</ol>\n</ul>");
        	break;
		
		case "xhtmllistaalfclip":
        		bbcodextra.insertAtCursor("<ul>\n<ol type=a>\n<li>" + bbcodextra.htmlreplace_CR(str_clipboard,"[*]*") + "</li>\n</ol>\n</ul>");
        	break;	
						
      		default : alert("Nessuna opzione selezionata!");
    		}//end switch		
	},



	
	insertAtCursor: function(aText) {
	//Codice originale: http://kb.mozillazine.org/index.phtml?title=Dev_:_Tips_:_Inserting_text_at_cursor
    		try {
    			var command = "cmd_insertText";
    			var controller = document.commandDispatcher.getControllerForCommand(command);
    			var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
			
			if (controller && controller.isCommandEnabled(command)) {
      				controller = controller.QueryInterface(Components.interfaces.nsICommandController);
				      			
      			params = params.createInstance(Components.interfaces.nsICommandParams);
      			params.setStringValue("state_data", aText);
      			controller.doCommandWithParams(command, params);
      		    }
    		}catch (e) {
      			alert("Error: "+e);      			
    		}
  	},



  


  	replace_CR: function(myText,replaceWith){
  		//Ultima modifica Flod 08112004   
  		//Riferimento codice per la gestione dei caratteri di fine riga: http://www.jennifermadden.com/162/examples/stringEscape.html

  		var OS;
		
		//Prima di iniziare elimino gli spazi vuoti all'inizio della stringa
		while ( myText.length > 0 ){
			if (myText.charAt(0) == "\n") {
					myText=myText.substr(1,myText.length);
				}
			else { break; }
		}
			
		
  		myText = escape(myText);

  		for(i=0; i<myText.length; i++){
   			if(myText.indexOf("%0D%0A") > -1){
   				//Windows encodes returns as \r\n hex
   				myText=myText.replace("%0D%0A",replaceWith);     
   				OS="win";
   				}
   				else if(myText.indexOf("%0A") > -1){
   						//Unix encodes returns as \n hex
   						myText = myText.replace("%0A",replaceWith);     
   						OS="unix";
   						}
   						else if(myText.indexOf("%0D") > -1){
   							//Machintosh encodes returns as \r hex
   							myText = myText.replace("%0D",replaceWith);     
   							OS="mac";
   							}
  		}

		//Questa parte non riguarda la funzionalit dell'estensione, serve solamente a rendere pi leggibile il BBcode prodotto
  		//In base al sistema operativo aggiungo un ritorno prima del codice "[*]*", sostituendolo con "acapo[*]"
  		for(i=0; i<myText.length; i++){
   			if(OS=="win"){   
   				myText=myText.replace("[*]*","%0D%0A[*]");               
   				}
   				else if(OS=="unix"){   
   					myText=myText.replace("[*]*","%0A[*]");             
   					}
   					else if(OS=="mac"){
   						myText=myText.replace("[*]*","%0D[*]");
   						}
  		}     

  		myText = unescape(myText);
		
		//Quando opero su una stringa presa dagli appunti, all'inizio si trova un "\n[*]" di troppo da eliminare
		while ( myText.length > 0 ){
			if (myText.substr(0,4) == "\n[*]") {
					myText=myText.substr(4,myText.length);
				}
			else { break; }
		}
				
		//Se la fine della stringa  [*] posso eliminare questi 3 caratteri, visto che significa che sono state selezionate
		//righe vuote nell'elenco; ripeto fino a quando la stringhe finisce con caratteri diversi da [*]
		while ( myText.length > 0 ){
			if (myText.substr(myText.length-3,myText.length+1) == "[*]") {
					myText=myText.substr(0,myText.length-4);
				}
			else { break; }		
		}	
		
		//Parto dall'inizio ed elimino eventuali [*]\n (elementi di lista vuoti); in questo modo elimino tutti gli spazi vuoti all'interno della lista
		while ( myText.length > 0 ){
			if (myText.indexOf("[*]\n") == -1) {
			    break; //nessun elemento vuoto
			  }  else {
				    //Copio la stringa tranne il pezzo "[*]\n"
				    myText = myText.substr(0,myText.indexOf("[*]\n")) + myText.substr(myText.indexOf("[*]\n")+4,myText.length);		  
			  	  }		
		}			
		
  		return myText;
	},
	
	

  	htmlreplace_CR: function(myText,replaceWith){
  		//Ultima modifica Flod 08112004   
  		//Riferimento codice per la gestione dei caratteri di fine riga: http://www.jennifermadden.com/162/examples/stringEscape.html

  		var OS;
		
		//Prima di iniziare elimino gli spazi vuoti all'inizio della stringa
		while ( myText.length > 0 ){
			if (myText.charAt(0) == "\n") {
					myText=myText.substr(1,myText.length);
				}
			else { break; }	
		}
		
		
  		myText = escape(myText);

  		for(i=0; i<myText.length; i++){
   			if(myText.indexOf("%0D%0A") > -1){
   				//Windows encodes returns as \r\n hex
   				myText=myText.replace("%0D%0A",replaceWith);     
   				OS="win";
   				}
   				else if(myText.indexOf("%0A") > -1){
   						//Unix encodes returns as \n hex
   						myText = myText.replace("%0A",replaceWith);     
   						OS="unix";
   						}
   						else if(myText.indexOf("%0D") > -1){
   							//Machintosh encodes returns as \r hex
   							myText = myText.replace("%0D",replaceWith);     
   							OS="mac";
   							}
  		}

  		//Questa parte non riguarda la funzionalit dell'estensione, serve solamente a rendere pi leggibile il BBcode prodotto
  		//In base al sistema operativo aggiungo un ritorno prima del codice "[*]*", sostituendolo con "acapo[*]"
  		for(i=0; i<myText.length; i++){
   			if(OS=="win"){   
   				myText=myText.replace("[*]*","</li>%0D%0A<li>");               
   				}
   				else if(OS=="unix"){   
   					myText=myText.replace("[*]*","</li>%0A<li>");             
   					}
   					else if(OS=="mac"){
   						myText=myText.replace("[*]*","</li>%0D<li>");
   						}
  		}     
		
  		myText = unescape(myText);

		//Quando opero su una stringa presa dagli appunti, all'inizio si trova un "</li>\n<li>" di troppo da eliminare
				
		while ( myText.length > 0 ){
			if (myText.substr(0,10) == "</li>\n<li>") {
					myText=myText.substr(10,myText.length);
				}
			else { break; }
		}
		
		//Se la fine della stringa  "<li>" posso eliminare questi caratteri ed il "\n</li>" (in tutto 10) che li precederono
		//( stata selezionata una riga vuota)	
		while ( myText.length > 0 ){
			if (myText.substr(myText.length-4,myText.length+1) == "<li>") {
					myText=myText.substr(0,myText.length-10);
				}			
			else { break; }		
		}			
		
		//Parto dall'inizio ed elimino eventuali <li></li>\n (elementi di lista vuoti); in questo modo elimino tutti gli spazi vuoti all'interno della lista
		while ( myText.length > 0 ){
			if (myText.indexOf("<li></li>\n") == -1) {
			    break; //nessun elemento vuoto
			  }  else {
				    //Copio la stringa tranne il pezzo "[*]\n"
				    myText = myText.substr(0,myText.indexOf("<li></li>\n")) + myText.substr(myText.indexOf("<li></li>\n")+10,myText.length);		  
			  	  }		
		}	
  		
  		return myText;
	},

	
	
	//Carico tutte le preferenze con un ciclo; questa funzione viene chiamata sull'onload della finestra bbcodextraPrefs.xul
	caricaPreferenze: function(){	   
	  var i;
	  try {
	  	for (i=0; i<nomi_checkbox.length;++i) {
	      	 var preferenza = document.getElementById(nomi_checkbox[i]);      
	      	 preferenza.checked = preferenze.GetBoolPref(preferenza.getAttribute("prefstring"));
	    	}
	      } catch(e) { 
	        var messaggio;
	        var strRes = document.getElementById('strRes');
		messaggio = strRes.getString("ERR_LOAD_PREFS") + e + "*)";      	       
	        alert(messaggio); 
	       };
	  //sistemo l'abilitazione di vbulletin
	  document.getElementById("bbcodextra-enable-vbulletin").disabled = !document.getElementById("bbcodextra-enable-bbcode").checked;	        
	},
	

	
	//Carico tutte le preferenze con un ciclo; questa funzione viene chiamata sull'onaccept della finestra bbcodextraPrefs.xul
	salvaPreferenze: function(){
	  var i;
	  try {
	  	for (i=0; i<nomi_checkbox.length;++i) {
	      	 var preferenza = document.getElementById(nomi_checkbox[i]);      
	      	 preferenze.SetBoolPref(preferenza.getAttribute("prefstring"),preferenza.checked);
	    	}
	      } catch(e) { 
	        var messaggio;
	        var strRes = document.getElementById('strRes');
		messaggio = strRes.getString("ERR_SAVE_PREFS") + e + "*)";      	       
	        alert(messaggio); 
	       };      
	},
	
	
	//Abilito/disabilito il menu vbulletin
	abilitaVBulletin: function(){	  
		 /*lo stato disabled del menu vbulletin  contrario allo stato checked del menu bbcode
		   bbcode attivo => vbulletin.disabled=false
		   bbcode disattivo => vbulletin.disabled=true*/
		 document.getElementById("bbcodextra-enable-vbulletin").disabled = !document.getElementById("bbcodextra-enable-bbcode").checked;	 
	}
}

	
window.addEventListener('load', bbcodextra.init, false); 	
